1# Test framework for git. See t/README for usage.
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
17
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
70# For repeatability, reset the environment to known value.
71LANG=C
72LC_ALL=C
73PAGER=cat
74TZ=UTC
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
77EDITOR=:
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 CURL_VERBOSE
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
98')
99unset XDG_CONFIG_HOME
100unset GITPERLLIB
101GIT_AUTHOR_EMAIL=author@example.com
102GIT_AUTHOR_NAME='A U Thor'
103GIT_COMMITTER_EMAIL=committer@example.com
104GIT_COMMITTER_NAME='C O Mitter'
105GIT_MERGE_VERBOSITY=5
106GIT_MERGE_AUTOEDIT=no
107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110export EDITOR
111
112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113GIT_TRACE_BARE=1
114export GIT_TRACE_BARE
115
116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
120fi
121
122# Add libc MALLOC and MALLOC_PERTURB test
123# only if we are not executing the test with valgrind
124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
126then
127 setup_malloc_check () {
128 : nothing
129 }
130 teardown_malloc_check () {
131 : nothing
132 }
133else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 }
141fi
142
143# Protect ourselves from common misconfiguration to export
144# CDPATH into the environment
145unset CDPATH
146
147unset GREP_OPTIONS
148unset UNZIP
149
150case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1511|2|true)
152 echo "* warning: Some tests will not work if GIT_TRACE" \
153 "is set as to trace on STDERR ! *"
154 echo "* warning: Please set GIT_TRACE to something" \
155 "other than 1, 2 or true ! *"
156 ;;
157esac
158
159# Convenience
160#
161# A regexp to match 5 and 40 hexdigits
162_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
163_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
164
165# Zero SHA-1
166_z40=0000000000000000000000000000000000000000
167
168# Line feed
169LF='
170'
171
172export _x05 _x40 _z40 LF
173
174# Each test should start with something like this, after copyright notices:
175#
176# test_description='Description of this test...
177# This test checks if command xyzzy does the right thing...
178# '
179# . ./test-lib.sh
180[ "x$ORIGINAL_TERM" != "xdumb" ] && (
181 TERM=$ORIGINAL_TERM &&
182 export TERM &&
183 [ -t 1 ] &&
184 tput bold >/dev/null 2>&1 &&
185 tput setaf 1 >/dev/null 2>&1 &&
186 tput sgr0 >/dev/null 2>&1
187 ) &&
188 color=t
189
190while test "$#" -ne 0
191do
192 case "$1" in
193 -d|--d|--de|--deb|--debu|--debug)
194 debug=t; shift ;;
195 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
196 immediate=t; shift ;;
197 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
198 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
199 -r)
200 shift; test "$#" -ne 0 || {
201 echo 'error: -r requires an argument' >&2;
202 exit 1;
203 }
204 run_list=$1; shift ;;
205 --run=*)
206 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
207 -h|--h|--he|--hel|--help)
208 help=t; shift ;;
209 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
210 verbose=t; shift ;;
211 --verbose-only=*)
212 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
213 shift ;;
214 -q|--q|--qu|--qui|--quie|--quiet)
215 # Ignore --quiet under a TAP::Harness. Saying how many tests
216 # passed without the ok/not ok details is always an error.
217 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
218 --with-dashes)
219 with_dashes=t; shift ;;
220 --no-color)
221 color=; shift ;;
222 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
223 valgrind=memcheck
224 shift ;;
225 --valgrind=*)
226 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
227 shift ;;
228 --valgrind-only=*)
229 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
230 shift ;;
231 --tee)
232 shift ;; # was handled already
233 --root=*)
234 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
235 shift ;;
236 *)
237 echo "error: unknown test option '$1'" >&2; exit 1 ;;
238 esac
239done
240
241if test -n "$valgrind_only"
242then
243 test -z "$valgrind" && valgrind=memcheck
244 test -z "$verbose" && verbose_only="$valgrind_only"
245elif test -n "$valgrind"
246then
247 verbose=t
248fi
249
250if test -n "$color"
251then
252 say_color () {
253 (
254 TERM=$ORIGINAL_TERM
255 export TERM
256 case "$1" in
257 error)
258 tput bold; tput setaf 1;; # bold red
259 skip)
260 tput setaf 4;; # blue
261 warn)
262 tput setaf 3;; # brown/yellow
263 pass)
264 tput setaf 2;; # green
265 info)
266 tput setaf 6;; # cyan
267 *)
268 test -n "$quiet" && return;;
269 esac
270 shift
271 printf "%s" "$*"
272 tput sgr0
273 echo
274 )
275 }
276else
277 say_color() {
278 test -z "$1" && test -n "$quiet" && return
279 shift
280 printf "%s\n" "$*"
281 }
282fi
283
284error () {
285 say_color error "error: $*"
286 GIT_EXIT_OK=t
287 exit 1
288}
289
290say () {
291 say_color info "$*"
292}
293
294test "${test_description}" != "" ||
295error "Test script did not set test_description."
296
297if test "$help" = "t"
298then
299 printf '%s\n' "$test_description"
300 exit 0
301fi
302
303exec 5>&1
304exec 6<&0
305if test "$verbose" = "t"
306then
307 exec 4>&2 3>&1
308else
309 exec 4>/dev/null 3>/dev/null
310fi
311
312test_failure=0
313test_count=0
314test_fixed=0
315test_broken=0
316test_success=0
317
318test_external_has_tap=0
319
320die () {
321 code=$?
322 if test -n "$GIT_EXIT_OK"
323 then
324 exit $code
325 else
326 echo >&5 "FATAL: Unexpected exit with code $code"
327 exit 1
328 fi
329}
330
331GIT_EXIT_OK=
332trap 'die' EXIT
333
334# The user-facing functions are loaded from a separate file so that
335# test_perf subshells can have them too
336. "$TEST_DIRECTORY/test-lib-functions.sh"
337
338# You are not expected to call test_ok_ and test_failure_ directly, use
339# the test_expect_* functions instead.
340
341test_ok_ () {
342 test_success=$(($test_success + 1))
343 say_color "" "ok $test_count - $@"
344}
345
346test_failure_ () {
347 test_failure=$(($test_failure + 1))
348 say_color error "not ok $test_count - $1"
349 shift
350 printf '%s\n' "$*" | sed -e 's/^/# /'
351 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
352}
353
354test_known_broken_ok_ () {
355 test_fixed=$(($test_fixed+1))
356 say_color error "ok $test_count - $@ # TODO known breakage vanished"
357}
358
359test_known_broken_failure_ () {
360 test_broken=$(($test_broken+1))
361 say_color warn "not ok $test_count - $@ # TODO known breakage"
362}
363
364test_debug () {
365 test "$debug" = "" || eval "$1"
366}
367
368match_pattern_list () {
369 arg="$1"
370 shift
371 test -z "$*" && return 1
372 for pattern_
373 do
374 case "$arg" in
375 $pattern_)
376 return 0
377 esac
378 done
379 return 1
380}
381
382match_test_selector_list () {
383 title="$1"
384 shift
385 arg="$1"
386 shift
387 test -z "$1" && return 0
388
389 # Both commas and whitespace are accepted as separators.
390 OLDIFS=$IFS
391 IFS=' ,'
392 set -- $1
393 IFS=$OLDIFS
394
395 # If the first selector is negative we include by default.
396 include=
397 case "$1" in
398 !*) include=t ;;
399 esac
400
401 for selector
402 do
403 orig_selector=$selector
404
405 positive=t
406 case "$selector" in
407 !*)
408 positive=
409 selector=${selector##?}
410 ;;
411 esac
412
413 test -z "$selector" && continue
414
415 case "$selector" in
416 *-*)
417 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
418 then
419 echo "error: $title: invalid non-numeric in range" \
420 "start: '$orig_selector'" >&2
421 exit 1
422 fi
423 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
424 then
425 echo "error: $title: invalid non-numeric in range" \
426 "end: '$orig_selector'" >&2
427 exit 1
428 fi
429 ;;
430 *)
431 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
432 then
433 echo "error: $title: invalid non-numeric in test" \
434 "selector: '$orig_selector'" >&2
435 exit 1
436 fi
437 esac
438
439 # Short cut for "obvious" cases
440 test -z "$include" && test -z "$positive" && continue
441 test -n "$include" && test -n "$positive" && continue
442
443 case "$selector" in
444 -*)
445 if test $arg -le ${selector#-}
446 then
447 include=$positive
448 fi
449 ;;
450 *-)
451 if test $arg -ge ${selector%-}
452 then
453 include=$positive
454 fi
455 ;;
456 *-*)
457 if test ${selector%%-*} -le $arg \
458 && test $arg -le ${selector#*-}
459 then
460 include=$positive
461 fi
462 ;;
463 *)
464 if test $arg -eq $selector
465 then
466 include=$positive
467 fi
468 ;;
469 esac
470 done
471
472 test -n "$include"
473}
474
475maybe_teardown_verbose () {
476 test -z "$verbose_only" && return
477 exec 4>/dev/null 3>/dev/null
478 verbose=
479}
480
481last_verbose=t
482maybe_setup_verbose () {
483 test -z "$verbose_only" && return
484 if match_pattern_list $test_count $verbose_only
485 then
486 exec 4>&2 3>&1
487 # Emit a delimiting blank line when going from
488 # non-verbose to verbose. Within verbose mode the
489 # delimiter is printed by test_expect_*. The choice
490 # of the initial $last_verbose is such that before
491 # test 1, we do not print it.
492 test -z "$last_verbose" && echo >&3 ""
493 verbose=t
494 else
495 exec 4>/dev/null 3>/dev/null
496 verbose=
497 fi
498 last_verbose=$verbose
499}
500
501maybe_teardown_valgrind () {
502 test -z "$GIT_VALGRIND" && return
503 GIT_VALGRIND_ENABLED=
504}
505
506maybe_setup_valgrind () {
507 test -z "$GIT_VALGRIND" && return
508 if test -z "$valgrind_only"
509 then
510 GIT_VALGRIND_ENABLED=t
511 return
512 fi
513 GIT_VALGRIND_ENABLED=
514 if match_pattern_list $test_count $valgrind_only
515 then
516 GIT_VALGRIND_ENABLED=t
517 fi
518}
519
520test_eval_ () {
521 # This is a separate function because some tests use
522 # "return" to end a test_expect_success block early.
523 eval </dev/null >&3 2>&4 "$*"
524}
525
526test_run_ () {
527 test_cleanup=:
528 expecting_failure=$2
529 setup_malloc_check
530 test_eval_ "$1"
531 eval_ret=$?
532 teardown_malloc_check
533
534 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
535 then
536 setup_malloc_check
537 test_eval_ "$test_cleanup"
538 teardown_malloc_check
539 fi
540 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
541 then
542 echo ""
543 fi
544 return "$eval_ret"
545}
546
547test_start_ () {
548 test_count=$(($test_count+1))
549 maybe_setup_verbose
550 maybe_setup_valgrind
551}
552
553test_finish_ () {
554 echo >&3 ""
555 maybe_teardown_valgrind
556 maybe_teardown_verbose
557}
558
559test_skip () {
560 to_skip=
561 skipped_reason=
562 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
563 then
564 to_skip=t
565 skipped_reason="GIT_SKIP_TESTS"
566 fi
567 if test -z "$to_skip" && test -n "$test_prereq" &&
568 ! test_have_prereq "$test_prereq"
569 then
570 to_skip=t
571
572 of_prereq=
573 if test "$missing_prereq" != "$test_prereq"
574 then
575 of_prereq=" of $test_prereq"
576 fi
577 skipped_reason="missing $missing_prereq${of_prereq}"
578 fi
579 if test -z "$to_skip" && test -n "$run_list" &&
580 ! match_test_selector_list '--run' $test_count "$run_list"
581 then
582 to_skip=t
583 skipped_reason="--run"
584 fi
585
586 case "$to_skip" in
587 t)
588 say_color skip >&3 "skipping test: $@"
589 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
590 : true
591 ;;
592 *)
593 false
594 ;;
595 esac
596}
597
598# stub; perf-lib overrides it
599test_at_end_hook_ () {
600 :
601}
602
603test_done () {
604 GIT_EXIT_OK=t
605
606 if test -z "$HARNESS_ACTIVE"
607 then
608 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
609 mkdir -p "$test_results_dir"
610 base=${0##*/}
611 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
612
613 cat >>"$test_results_path" <<-EOF
614 total $test_count
615 success $test_success
616 fixed $test_fixed
617 broken $test_broken
618 failed $test_failure
619
620 EOF
621 fi
622
623 if test "$test_fixed" != 0
624 then
625 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
626 fi
627 if test "$test_broken" != 0
628 then
629 say_color warn "# still have $test_broken known breakage(s)"
630 fi
631 if test "$test_broken" != 0 || test "$test_fixed" != 0
632 then
633 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
634 msg="remaining $test_remaining test(s)"
635 else
636 test_remaining=$test_count
637 msg="$test_count test(s)"
638 fi
639 case "$test_failure" in
640 0)
641 # Maybe print SKIP message
642 if test -n "$skip_all" && test $test_count -gt 0
643 then
644 error "Can't use skip_all after running some tests"
645 fi
646 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
647
648 if test $test_external_has_tap -eq 0
649 then
650 if test $test_remaining -gt 0
651 then
652 say_color pass "# passed all $msg"
653 fi
654 say "1..$test_count$skip_all"
655 fi
656
657 test -d "$remove_trash" &&
658 cd "$(dirname "$remove_trash")" &&
659 rm -rf "$(basename "$remove_trash")"
660
661 test_at_end_hook_
662
663 exit 0 ;;
664
665 *)
666 if test $test_external_has_tap -eq 0
667 then
668 say_color error "# failed $test_failure among $msg"
669 say "1..$test_count"
670 fi
671
672 exit 1 ;;
673
674 esac
675}
676
677if test -n "$valgrind"
678then
679 make_symlink () {
680 test -h "$2" &&
681 test "$1" = "$(readlink "$2")" || {
682 # be super paranoid
683 if mkdir "$2".lock
684 then
685 rm -f "$2" &&
686 ln -s "$1" "$2" &&
687 rm -r "$2".lock
688 else
689 while test -d "$2".lock
690 do
691 say "Waiting for lock on $2."
692 sleep 1
693 done
694 fi
695 }
696 }
697
698 make_valgrind_symlink () {
699 # handle only executables, unless they are shell libraries that
700 # need to be in the exec-path.
701 test -x "$1" ||
702 test "# " = "$(head -c 2 <"$1")" ||
703 return;
704
705 base=$(basename "$1")
706 symlink_target=$GIT_BUILD_DIR/$base
707 # do not override scripts
708 if test -x "$symlink_target" &&
709 test ! -d "$symlink_target" &&
710 test "#!" != "$(head -c 2 < "$symlink_target")"
711 then
712 symlink_target=../valgrind.sh
713 fi
714 case "$base" in
715 *.sh|*.perl)
716 symlink_target=../unprocessed-script
717 esac
718 # create the link, or replace it if it is out of date
719 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
720 }
721
722 # override all git executables in TEST_DIRECTORY/..
723 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
724 mkdir -p "$GIT_VALGRIND"/bin
725 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
726 do
727 make_valgrind_symlink $file
728 done
729 # special-case the mergetools loadables
730 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
731 OLDIFS=$IFS
732 IFS=:
733 for path in $PATH
734 do
735 ls "$path"/git-* 2> /dev/null |
736 while read file
737 do
738 make_valgrind_symlink "$file"
739 done
740 done
741 IFS=$OLDIFS
742 PATH=$GIT_VALGRIND/bin:$PATH
743 GIT_EXEC_PATH=$GIT_VALGRIND/bin
744 export GIT_VALGRIND
745 GIT_VALGRIND_MODE="$valgrind"
746 export GIT_VALGRIND_MODE
747 GIT_VALGRIND_ENABLED=t
748 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
749 export GIT_VALGRIND_ENABLED
750elif test -n "$GIT_TEST_INSTALLED"
751then
752 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
753 error "Cannot run git from $GIT_TEST_INSTALLED."
754 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
755 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756else # normal case, use ../bin-wrappers only unless $with_dashes:
757 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
758 if ! test -x "$git_bin_dir/git"
759 then
760 if test -z "$with_dashes"
761 then
762 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
763 fi
764 with_dashes=t
765 fi
766 PATH="$git_bin_dir:$PATH"
767 GIT_EXEC_PATH=$GIT_BUILD_DIR
768 if test -n "$with_dashes"
769 then
770 PATH="$GIT_BUILD_DIR:$PATH"
771 fi
772fi
773GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
774GIT_CONFIG_NOSYSTEM=1
775GIT_ATTR_NOSYSTEM=1
776export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
777
778if test -z "$GIT_TEST_CMP"
779then
780 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
781 then
782 GIT_TEST_CMP="$DIFF -c"
783 else
784 GIT_TEST_CMP="$DIFF -u"
785 fi
786fi
787
788GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
789export GITPERLLIB
790test -d "$GIT_BUILD_DIR"/templates/blt || {
791 error "You haven't built things yet, have you?"
792}
793
794if ! test -x "$GIT_BUILD_DIR"/test-chmtime
795then
796 echo >&2 'You need to build test-chmtime:'
797 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
798 exit 1
799fi
800
801# Test repository
802TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
803test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
804case "$TRASH_DIRECTORY" in
805/*) ;; # absolute path is good
806 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
807esac
808test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
809rm -fr "$TRASH_DIRECTORY" || {
810 GIT_EXIT_OK=t
811 echo >&5 "FATAL: Cannot prepare test area"
812 exit 1
813}
814
815HOME="$TRASH_DIRECTORY"
816export HOME
817
818if test -z "$TEST_NO_CREATE_REPO"
819then
820 test_create_repo "$TRASH_DIRECTORY"
821else
822 mkdir -p "$TRASH_DIRECTORY"
823fi
824# Use -P to resolve symlinks in our working directory so that the cwd
825# in subprocesses like git equals our $PWD (for pathname comparisons).
826cd -P "$TRASH_DIRECTORY" || exit 1
827
828this_test=${0##*/}
829this_test=${this_test%%-*}
830if match_pattern_list "$this_test" $GIT_SKIP_TESTS
831then
832 say_color info >&3 "skipping test $this_test altogether"
833 skip_all="skip all tests in $this_test"
834 test_done
835fi
836
837# Provide an implementation of the 'yes' utility
838yes () {
839 if test $# = 0
840 then
841 y=y
842 else
843 y="$*"
844 fi
845
846 while echo "$y"
847 do
848 :
849 done
850}
851
852# Fix some commands on Windows
853case $(uname -s) in
854*MINGW*)
855 # Windows has its own (incompatible) sort and find
856 sort () {
857 /usr/bin/sort "$@"
858 }
859 find () {
860 /usr/bin/find "$@"
861 }
862 sum () {
863 md5sum "$@"
864 }
865 # git sees Windows-style pwd
866 pwd () {
867 builtin pwd -W
868 }
869 # no POSIX permissions
870 # backslashes in pathspec are converted to '/'
871 # exec does not inherit the PID
872 test_set_prereq MINGW
873 test_set_prereq SED_STRIPS_CR
874 test_set_prereq GREP_STRIPS_CR
875 GIT_TEST_CMP=mingw_test_cmp
876 ;;
877*CYGWIN*)
878 test_set_prereq POSIXPERM
879 test_set_prereq EXECKEEPSPID
880 test_set_prereq CYGWIN
881 test_set_prereq SED_STRIPS_CR
882 test_set_prereq GREP_STRIPS_CR
883 ;;
884*)
885 test_set_prereq POSIXPERM
886 test_set_prereq BSLASHPSPEC
887 test_set_prereq EXECKEEPSPID
888 ;;
889esac
890
891( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
892test -z "$NO_PERL" && test_set_prereq PERL
893test -z "$NO_PYTHON" && test_set_prereq PYTHON
894test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
895test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
896
897# Can we rely on git's output in the C locale?
898if test -n "$GETTEXT_POISON"
899then
900 GIT_GETTEXT_POISON=YesPlease
901 export GIT_GETTEXT_POISON
902 test_set_prereq GETTEXT_POISON
903else
904 test_set_prereq C_LOCALE_OUTPUT
905fi
906
907# Use this instead of test_cmp to compare files that contain expected and
908# actual output from git commands that can be translated. When running
909# under GETTEXT_POISON this pretends that the command produced expected
910# results.
911test_i18ncmp () {
912 test -n "$GETTEXT_POISON" || test_cmp "$@"
913}
914
915# Use this instead of "grep expected-string actual" to see if the
916# output from a git command that can be translated either contains an
917# expected string, or does not contain an unwanted one. When running
918# under GETTEXT_POISON this pretends that the command produced expected
919# results.
920test_i18ngrep () {
921 if test -n "$GETTEXT_POISON"
922 then
923 : # pretend success
924 elif test "x!" = "x$1"
925 then
926 shift
927 ! grep "$@"
928 else
929 grep "$@"
930 fi
931}
932
933test_lazy_prereq PIPE '
934 # test whether the filesystem supports FIFOs
935 case $(uname -s) in
936 CYGWIN*)
937 false
938 ;;
939 *)
940 rm -f testfifo && mkfifo testfifo
941 ;;
942 esac
943'
944
945test_lazy_prereq SYMLINKS '
946 # test whether the filesystem supports symbolic links
947 ln -s x y && test -h y
948'
949
950test_lazy_prereq FILEMODE '
951 test "$(git config --bool core.filemode)" = true
952'
953
954test_lazy_prereq CASE_INSENSITIVE_FS '
955 echo good >CamelCase &&
956 echo bad >camelcase &&
957 test "$(cat CamelCase)" != good
958'
959
960test_lazy_prereq UTF8_NFD_TO_NFC '
961 # check whether FS converts nfd unicode to nfc
962 auml=$(printf "\303\244")
963 aumlcdiar=$(printf "\141\314\210")
964 >"$auml" &&
965 case "$(echo *)" in
966 "$aumlcdiar")
967 true ;;
968 *)
969 false ;;
970 esac
971'
972
973test_lazy_prereq AUTOIDENT '
974 sane_unset GIT_AUTHOR_NAME &&
975 sane_unset GIT_AUTHOR_EMAIL &&
976 git var GIT_AUTHOR_IDENT
977'
978
979test_lazy_prereq EXPENSIVE '
980 test -n "$GIT_TEST_LONG"
981'
982
983test_lazy_prereq USR_BIN_TIME '
984 test -x /usr/bin/time
985'
986
987# When the tests are run as root, permission tests will report that
988# things are writable when they shouldn't be.
989test -w / || test_set_prereq SANITY
990
991GIT_UNZIP=${GIT_UNZIP:-unzip}
992test_lazy_prereq UNZIP '
993 "$GIT_UNZIP" -v
994 test $? -ne 127
995'